//+------------------------------------------------------------------+
//|                                                    NSNDAlert.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
extern int maxspread=100;
extern int candlecount=10;
static int prevtimePNS=0;
static int prevtimeCNS=0;
static int prevtimePND=0;
static int prevtimeCND=0;

int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  //if(Seconds()>10)
  {
   int    counted_bars=IndicatorCounted();
  // string comment="";
//----
double points=Point*maxspread*10;
//Comment(points);
   bool LowVolume[10000];
   bool bear[10000];
   bool bull[10000];
   bool pins[10000];
   int bearcloseabove[10000];
   bool bearclosebelow[10000];
   int bullclosebelow[10000];
   bool bullcloseabove[10000];
   int prevbelowcount=0;
   int prevabovecount=0;
   int count=candlecount;
   int pinno=0;
   string comment[10];
   int i;
   if(Period()==60)
   {
   maxspread=3000;
   }
   for (i=1; i<=count; i++)
   {
     comment[i]="("+i+") " ;
    bear[i]=false;
    bull[i]=false;
      if(Open[i]>Close[i])
   {
   if(High[i]-Low[i]<points)
   {
    bear[i]=true;
    comment[i]=comment[i]+"Bear ";
    }
   }
   if(Close[i]>Open[i])
   {
    if(High[i]-Low[i]<points)
    {

    bull[i]=true;
    comment[i]=comment[i]+"Bull ";
    }
   }
   }
   
   for (i=1; i<=count; i++)
   {
   
     LowVolume[i]=False;
     if(Volume[i]<Volume[i+1] && Volume[i]<Volume[i+2])
     {
       LowVolume[i]=True;
       comment[i]=comment[i]+"Low Vol ";
    }
  }
   
   
     
   for (i=1; i<=count; i++)
   {
     pins[i]=false;


   double pip=Point*5;
  
   if(bear[i] && High[i]>Open[i]+pip && Low[i]<Close[i]-pip)
   {
    pins[i]=true;
    comment[i]=comment[i]+" Pins";
   }
   if(bull[i] && High[i]>Close[i]+pip && Low[i]<Open[i]-pip)
   {
    
    pins[i]=true;
    comment[i]=comment[i]+" Pins";
   }
   }
   
   
   for (i=1; i<=count; i++)
   {
    //comment[i]=comment[i]+i+"i";
     bearcloseabove[i]=0;
     bullclosebelow[i]=0;
     bullcloseabove[i]=false;
     bearclosebelow[i]=false;    
     for (int ix=1; ix<=i; ix++)
     {
      //   comment[i]=comment[i]+ix+"ix";
       if(bear[i]==true && Close[ix]<Low[i])
       {
        if(!bearclosebelow[i])
        {
        comment[i]=comment[i]+" Close Below ";
        }
        bearclosebelow[i]=true;
       }
       if(bear[i]==true && Close[ix]>High[i])
       {
        if(!bearcloseabove[i])
        {
        comment[i]=comment[i]+" Close Above ";
        }
        bearcloseabove[i]++;
       }
       
       
       
       
       
       if(bull[i]==true && Close[ix]>High[i])
       {
       if(!bullcloseabove[i])
        {
          comment[i]=comment[i]+" Close Above ";
      
        }
        bullcloseabove[i]=true;
       }
       
       if(bull[i]==true && Close[ix]<Low[i])
       {
       if(!bullclosebelow[i])
        {
          comment[i]=comment[i]+" Close Below ";
      
        }
        bullclosebelow[i]++;
       }
       
     }
   
   
   
      
  
   }
  // Comment(" ");
//----

   
   for (i=1; i<=count; i++)
   {
    if(bull[i] && LowVolume[i] && pins[i] && !bullcloseabove[i] && bullclosebelow[i]==0)
    {
     comment[i]=comment[i]+" Potential No Demand Candle -"+i;
    }
    if(Close[0]<Low[i] && bull[i] && LowVolume[i] && pins[i] && !bullcloseabove[i] && bullclosebelow[i]==0)
    {
      if(Time[0]!=prevtimePND)
      {
        Alert(Symbol()+Period()+" Potential No Demand Candle -"+(i+1));
        prevtimePND=Time[0];
      }
    }
    if(Close[1]<Low[i] && bull[i] && LowVolume[i] && pins[i] && !bullcloseabove[i] && bullclosebelow[i]<2)
    {
      if(Time[0]!=prevtimeCND)
      {
        Alert(Symbol()+Period()+" Confirmed No Demand Candle -"+(i+1));
        prevtimeCND=Time[0];
      }
    }
    
    if(bear[i] && LowVolume[i] && pins[i] && !bearclosebelow[i] && bearcloseabove[i]==0)
    {
    comment[i]=comment[i]+" Potential No Supply Candle -"+i;
    }
    
    if(Close[0]>High[i] && bear[i] && LowVolume[i] && pins[i] && !bearclosebelow[i]  && bearcloseabove[i]==0)
    {
      if(Time[0]!=prevtimePNS)
      {   
        Alert(Symbol()+Period()+" Potential No Supply Candle -"+(i+1));
        prevtimePNS=Time[0];
      }
    }
    
    if(Close[1]>High[i] && bear[i] && LowVolume[i] && pins[i] && !bearclosebelow[i]  && bearcloseabove[i]<2)
    {
      if(Time[0]!=prevtimeCNS)
      {   
        Alert(Symbol()+Period()+" Confirmed No Supply Candle -"+(i+1));
        prevtimeCNS=Time[0];
      }
    }
   
   } // end for
 
//
string fullcomment;
for (i=1; i<=count; i++)
{
fullcomment=fullcomment+comment[i]+"\n";
}
//Comment(fullcomment);
   return(0);
  }
  }
//+------------------------------------------------------------------+